'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AuthRoute = exports.withAuth = exports.AuthProvider = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _recompose = require('recompose');

var _reactRouterDom = require('react-router-dom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function Blank() {
  return null;
}

var AuthProvider = exports.AuthProvider = function (_Component) {
  _inherits(AuthProvider, _Component);

  function AuthProvider(props) {
    _classCallCheck(this, AuthProvider);

    var _this = _possibleConstructorReturn(this, (AuthProvider.__proto__ || Object.getPrototypeOf(AuthProvider)).call(this, props));

    _this.onLoginSuccess = function (authInfo, cb) {
      _this.setState({ authInfo: authInfo, isLoggedIn: true }, cb);
    };

    _this.onLogout = function (cb) {
      _this.props.logout().then(function () {
        _this.setState({ authInfo: null, isLoggedIn: false }, function () {
          if (cb) {
            cb(function () {
              if (_this.props.redirectOnLogout) {
                _this.props.history.push(_this.props.redirectOnLogout);
              }
            });
          } else {
            if (_this.props.redirectOnLogout) {
              _this.props.history.push(_this.props.redirectOnLogout);
            }
          }
        });
      }).catch(function (err) {
        return console.error(err);
      });
    };

    _this.getChildContext = function () {
      return {
        isLoggedIn: _this.state.isLoggedIn,
        authInfo: _this.state.authInfo,
        onLoginSuccess: _this.onLoginSuccess,
        onLogout: _this.onLogout
      };
    };

    _this.state = {
      ready: false,
      isLoggedIn: false,
      authInfo: null
    };
    return _this;
  }

  _createClass(AuthProvider, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      this.props.whoami().then(function (_ref) {
        var data = _ref.data;

        var authInfo = _this2.props.getAuthInfo(data);
        _this2.setState({ authInfo: authInfo, isLoggedIn: true, ready: true });
      }).catch(function (err) {
        if (err.response && err.response.status === 401) {
          _this2.setState({ authInfo: null, isLoggedIn: false, ready: true });
        } else {
          console.error(err);
        }
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var LoadingComponent = this.props.loadingComponent;
      if (!this.state.ready) {
        return _react2.default.createElement(LoadingComponent, null);
      } else {
        return this.props.children;
      }
    }
  }]);

  return AuthProvider;
}(_react.Component);

AuthProvider.defaultProps = {
  getAuthInfo: function getAuthInfo(x) {
    return x;
  },
  loadingComponent: Blank,
  redirectOnLogout: null
};
AuthProvider.childContextTypes = {
  isLoggedIn: _propTypes2.default.bool,
  authInfo: _propTypes2.default.object,
  onLoginSuccess: _propTypes2.default.func,
  onLogout: _propTypes2.default.func
};


function PermissionDenied(props) {
  return _react2.default.createElement(
    'div',
    null,
    'Permission Denied'
  );
}

var AuthRouteBase = function (_Component2) {
  _inherits(AuthRouteBase, _Component2);

  function AuthRouteBase() {
    _classCallCheck(this, AuthRouteBase);

    return _possibleConstructorReturn(this, (AuthRouteBase.__proto__ || Object.getPrototypeOf(AuthRouteBase)).apply(this, arguments));
  }

  _createClass(AuthRouteBase, [{
    key: 'render',
    value: function render() {
      var _this4 = this;

      var _props = this.props,
          isLoggedIn = _props.isLoggedIn,
          loginRoute = _props.loginRoute,
          path = _props.path,
          authInfo = _props.authInfo,
          roleCheck = _props.roleCheck;

      var Component = this.props.component;
      var PermissionDeniedComponent = this.props.permissionDeniedComponent;
      return _react2.default.createElement(_reactRouterDom.Route, { exact: true, path: path, render: function render(props) {
          if (isLoggedIn) {
            if (roleCheck(authInfo)) {
              return _react2.default.createElement(Component, props);
            } else {
              return _react2.default.createElement(PermissionDeniedComponent, props);
            }
          } else {
            _this4.props.history.replace(loginRoute, { from: props.location });
            return null;
          }
        } });
    }
  }]);

  return AuthRouteBase;
}(_react.Component);

AuthRouteBase.defaultProps = {
  roleCheck: function roleCheck() {
    return true;
  },
  permissionDeniedComponent: PermissionDenied
};
var withAuth = exports.withAuth = (0, _recompose.getContext)(AuthProvider.childContextTypes);
var AuthRoute = exports.AuthRoute = (0, _reactRouterDom.withRouter)(withAuth(AuthRouteBase));